//****************************************************************************
//
// Borland Delphi Application
//
// Image Effect Processing Example
//  : ȯ
//  : 2003 10
// ۱ : ȯ, ̿ؾ().
// This is test part of SB_ImagePro Project File.
// Copyright 2003 by JSC&I (Mr.Bae). All rights reserved.
//****************************************************************************
unit Test1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, SB_ImageEffect, Buttons, ComCtrls,Math,
  SB_ImageEffectView;

type
  TForm1 = class(TForm)
    Image1: TImage;
    lstEffects: TListBox;
    TrackBar: TTrackBar;
    Label1: TLabel;
    edtTrack: TEdit;
    chkAuto: TCheckBox;
    btnApply: TBitBtn;
    Label2: TLabel;
    rdgRotate: TRadioGroup;
    Label3: TLabel;
    lblElapsed: TLabel;
    chkAntiAlias: TCheckBox;
    ScrollBox1: TScrollBox;
    Image2: TImage;
    Button1: TButton;
    procedure btnApplyClick(Sender: TObject);
    procedure lstEffectsClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rdgRotateClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    MouseDragPos,              // Cropping Ǵ 
    MouseMovePos: TPoint;
    MouseDragging: Boolean;
    MouseDrag2: Boolean;
    bUsed: Boolean; //blurring Ǵ 
    SBIE: TSBImageEffect;

    Procedure HideOptions;
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  public
    { Public declarations }

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
	SBIE := TSBImageEffect.Create;
	HideOptions();
	SBIE.SourceBmp.Assign (Image1.Picture.Bitmap);
end;

procedure TForm1.btnApplyClick(Sender: TObject);
Var
	i: Integer;
begin
  Screen.Cursor := crHourGlass;
  BtnAPPLY.Enabled := False;
  
  { E F F E C T S }
  Case lstEffects.ItemIndex of
   	 0: Image2.Picture.Assign( SBIE.Effect_GaussianBlur   (TrackBar.Position));
     1: Image2.Picture.Assign( SBIE.Effect_SplitBlur      (TrackBar.Position));
     2: Image2.Picture.Assign( SBIE.Effect_AddColorNoise  (TrackBar.Position * 3));
     3: Image2.Picture.Assign( SBIE.Effect_AddMonoNoise   (TrackBar.Position * 3));
     4: For i:=1 to TrackBar.Position do
        	Image2.Picture.Assign( SBIE.Effect_AntiAlias);
     5: Image2.Picture.Assign( SBIE.Effect_Contrast       (TrackBar.Position * 3));
     6: Image2.Picture.Assign( SBIE.Effect_FishEye        (TrackBar.Position div 10+1));
     7: Image2.Picture.Assign( SBIE.Effect_Lightness      (TrackBar.Position * 2));
     8: Image2.Picture.Assign( SBIE.Effect_Darkness       (TrackBar.Position * 2));
     9: Image2.Picture.Assign( SBIE.Effect_Saturation     (255-((TrackBar.Position * 255) div 100)));
    10: Image2.Picture.Assign( SBIE.Effect_Mosaic         (TrackBar.Position div 2));
    11: Image2.Picture.Assign( SBIE.Effect_Twist          (200-(TrackBar.Position * 2)+1));
    12: Image2.Picture.Assign( SBIE.Effect_Splitlight     (TrackBar.Position div 20));
    13: Image2.Picture.Assign( SBIE.Effect_Tile           (TrackBar.Position div 10));
    14: Image2.Picture.Assign( SBIE.Effect_SpotLight      (TrackBar.Position ,
                                              Rect (TrackBar.Position ,
                                              TrackBar.Position ,
                                              TrackBar.Position +TrackBar.Position*2,
                                              TrackBar.Position +TrackBar.Position*2)));
    15: Image2.Picture.Assign( SBIE.Effect_Trace          (TrackBar.Position div 10));
    16: For i:=1 to TrackBar.Position do
        	Image2.Picture.Assign( SBIE.Effect_Emboss);
    17: Image2.Picture.Assign( SBIE.Effect_Solarize       (255-((TrackBar.Position * 255) div 100)));
    18: Image2.Picture.Assign( SBIE.Effect_Posterize      (((TrackBar.Position * 255) div 100)+1));
    19: Image2.Picture.Assign( SBIE.Effect_Grayscale);
    20: Image2.Picture.Assign( SBIE.Effect_Invert);
    21: Image2.Picture.Assign( SBIE.Effect_FlipHorizontal);
    22: Image2.Picture.Assign( SBIE.Effect_FlipVertical);
    23:
    Begin
        case rdgRotate.ItemIndex Of
            0: i := 0;
            1: i := 90;
            2: i := 180;
            3: i := 270;
        End;
    	Image2.Picture.Assign( SBIE.Effect_Rotate90(i));
    End;
    24: // Zoom
    Begin
    	Image2.Picture.Assign( SBIE.Effect_Zoom(TrackBar.Position, chkAntiAlias.Checked));
    End;
    25: // Crop: Mouse drag&Drop ó
    	;
    26: // blur
    Begin
    	if (bUsed) Then
        	Image2.Picture.Assign( SBIE.Effect_Blur(Image2.Picture.Bitmap) )
        Else
    		Image2.Picture.Assign( SBIE.Effect_Blur() );
        bUsed := True;  // Blurring  ϱ  
        btnAPPLY.Enabled  := True;
    End;
    27: // Sharpen
    Begin
    	if (bUsed) Then
        	Image2.Picture.Assign ( SBIE.Effect_Sharpen(Image2.Picture.Bitmap) )
        Else
        	Image2.Picture.Assign( SBIE.Effect_Sharpen());
        bUsed := True;
        btnApply.Enabled := True;
    End;
    28: Image2.Picture.Assign( SBIE.Effect_Rotate(TrackBar.Position, chkAntiAlias.Checked));
    29: // SharpenEdge
    	Image2.Picture.Assign( SBIE.Effect_SharpenEdge());
    30: // Brighten
    	Image2.Picture.Assign( SBIE.Effect_Brighten());
    31: // Spray
    	Image2.Picture.Assign( SBIE.Effect_Spray(TrackBar.Position));
  End;{Case}
  Image2.Invalidate;
	Screen.Cursor := crDefault;
end;

procedure TForm1.lstEffectsClick(Sender: TObject);
begin
	HideOptions();
	Case lstEffects.ItemIndex of
  	23: // rotate
    Begin
    	TrackBar.Min := 0;
    	TrackBar.Max := 360;
			TrackBar.Position := 0;
        TrackBar.Frequency := 90;
        TrackBar.PageSize := 90;
    	rdgRotate.ItemIndex := 0; // Default.
      	rdgRotate.Visible := True;
    End;
  	24: // zoom
    Begin
    	TrackBar.Min := 10;
    	TrackBar.Max := 200;
        TrackBar.Position := 100; // default
        TrackBar.Frequency := 10;
        TrackBar.PageSize := 10;
			chkAntiAlias.Visible := True;
    End;
    25: // crop
    Begin
        Image1.OnMouseDown := ImageMouseDown;
        Image1.OnMouseMove := ImageMouseMove;
        Image1.OnMouseUp := ImageMouseUp;
    End;
    26,27: // blur/sharpen
    Begin
    	bUsed := False;
    End;
    28: // Rotate
    Begin
    	TrackBar.Min := 0;
    	TrackBar.Max := 360;
			TrackBar.Position := 0;
        TrackBar.Frequency := 45;
        TrackBar.PageSize := 45;
			chkAntiAlias.Visible := True;        
    End;
    31:
    Begin
    	TrackBar.Min := 1;
    	TrackBar.Max := 100;
        TrackBar.Position := 15;
        TrackBar.Frequency := 10;
        TrackBar.PageSize := 5;
    End;
    Else
    Begin
    	TrackBar.Min := 1;
    	TrackBar.Max := 100;
        TrackBar.Position := 1;
        TrackBar.Frequency := 1;
        TrackBar.PageSize := 10;
    End;

  End; // of case.

 	btnAPPLY.Enabled  := True;
 	TrackBar.Enabled  := True;
  If chkAuto.Checked Then	  btnAPPLY.Click;
  edtTrack.Text := IntToStr(TrackBar.Position);
end;

procedure TForm1.TrackBarChange(Sender: TObject);
begin
	if lstEffects.ItemIndex = 23 Then
  Begin
		Case TrackBar.Position Of
    	0: rdgRotate.ItemIndex := 0;
        90: rdgRotate.ItemIndex := 1;
        180:rdgRotate.ItemIndex := 2;
        270: rdgRotate.ItemIndex := 3;
    End;
  End;
 	If Not btnAPPLY.Enabled then BtnAPPLY.Enabled := True;
 	if chkAuto.Checked        then btnAPPLY.Click;
	edtTrack.Text := IntToStr(TrackBar.Position);
end;

procedure TForm1.rdgRotateClick(Sender: TObject);
begin
	If lstEffects.ItemIndex = 23 Then
	Begin
    Case rdgRotate.ItemIndex Of
    	0: TrackBar.Position := 0;
        1: TrackBar.Position := 90;
        2: TrackBar.Position := 180;
        3: TrackBar.Position := 270;
    End;
 		If Not btnAPPLY.Enabled then BtnAPPLY.Enabled := True;
 		if chkAuto.Checked        then btnAPPLY.Click;
  End;
end;

procedure TForm1.HideOptions;
begin
	rdgRotate.Visible := False;
	chkAntiAlias.Visible := False;
  Image1.OnMouseDown := Nil;
  Image1.OnMouseMove := Nil;
  Image1.OnMouseUp := Nil;
end;
//****************************************************************************
// User Defined Mouse Down Event
//****************************************************************************
procedure TForm1.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If (Button = mbRight) And Not (MouseDragging) then
  Begin
    MouseDragPos := Point(X, Y);
    MouseMovePos := Point(MouseDragPos.x+1, MouseDragPos.Y+1);
    MouseDragging := True;
    Image1.Cursor := crHandPoint;
  End;

end;

procedure TForm1.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  Procedure Swap(Var A, B: Integer);
  Begin
      A := A + B;
      B := A - B;
      A := A - B;
  End;
Var
	P1, P2: TPoint;
begin
  if MouseDragging Then
  begin
    // ٷ  簢 
    P1 := MouseDragPos; P2 := MouseMovePos;
    //If MouseDragPos.X > MouseMovePos.X Then 	Swap(P1.X, P2.X);
    //If MouseDragPos.Y > MouseMovePos.Y Then 	Swap(P1.Y, P2.Y);
    //Image1.Canvas.DrawFocusRect(Rect(P1, P2));
    Image1.Canvas.DrawFocusRect(Rect(Min(P1.X,P2.X),Min(P1.Y,P2.Y),Max(P1.X,P2.X), Max(P1.Y,P2.Y)));

    // 콺 巡 ġ  ġ  簢 ׸
    P1 := MouseDragPos; P2 := Point(X, Y);
    //If MouseDragPos.X > MouseMovePos.X Then   Swap(P1.X, P2.X);
    //If MouseDragPos.Y > MouseMovePos.Y Then   Swap(P1.Y, P2.Y);
    //Image1.Canvas.DrawFocusRect(Rect(P1, P2));
    Image1.Canvas.DrawFocusRect(Rect(Min(P1.X,P2.X),Min(P1.Y,P2.Y),Max(P1.X,P2.X), Max(P1.Y,P2.Y)));
    // ֱ 巡 ġ 
    MouseMovePos := Point(X,Y);
  end;
end;

procedure TForm1.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
	rBounds: TRect;
  Procedure Swap(Var A, B: Integer);
  Begin
      A := A + B;
      B := A - B;
      A := A - B;
  End;
begin
  if (Button = mbRight) And (MouseDragging) then
  begin
  	try
        //   ̹ Image2 
        If MouseDragPos.X > MouseMovePos.X Then
        	Swap(MouseDragPos.X, MouseMovePos.X);
        If MouseDragPos.Y > MouseMovePos.Y Then
        	Swap(MouseDragPos.Y, MouseMovePos.Y);

        rBounds := Rect(TPoint(MouseDragPos), TPoint(MouseMovePos));

        Image2.Picture.Assign( SBIE.Effect_Crop(rBounds) );
        // ٷ  簢   ʱȭ
        Image1.Canvas.DrawFocusRect(rBounds);
        MouseDragPos := Point(X, Y);
        MouseDragging := False;
        Image1.Cursor := crDefault;
    Finally
    	;
    End;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	SBIE.Free;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If (Button = mbLeft) And Not (MouseDragging) then
  Begin
    MouseDragPos := Point(X, Y);
    MouseMovePos := Point(MouseDragPos.x+1, MouseDragPos.Y+1);
    MouseDrag2 := True;
    Image1.Cursor := crHandPoint;
  End;

end;

procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var
	P1, P2, P3: TPoint;
begin
  if  MouseDrag2 Then
  begin
    // ٷ  簢 
    P1 := MouseDragPos; P2 := MouseMovePos;
    // 콺 巡 ġ  ġ  簢 ׸
    P3 := Point(X, Y);
    With ScrollBox1 Do
    Begin
    	HorzScrollBar.Position := HorzScrollBar.Position + (P2.X - P3.X);
        VertScrollBar.Position := VertScrollBar.Position + (P2.Y - P3.Y)
    End;
    // ֱ 巡 ġ 
    //MouseMovePos := Point(X,Y);
  end;

end;

procedure TForm1.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) And (MouseDrag2) then
  begin    
    MouseDragPos := Point(X, Y);
    MouseDrag2 := False;
    Image1.Cursor := crDefault;
  end;

end;

end.
