unit SB_ImageEffect;
//****************************************************************************
//
// Borland Delphi Visual Component Library
//
// Image Effect Processing Library
// ó Class
//  : ȯ
//  : 2003 10
// ۱ : ȯ, ̿ؾ().
// This is part of SB_ImagePro Project File.
// Copyright 2003 by JSC&I (Mr.Bae). All rights reserved.  
//****************************************************************************

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, Controls, Graphics,
  Math, SB_ImageCommon;

  
//******************************************************************************
Type
	TSBImageEffectType = (
  	etNone, etInvert, etAddColorNoise, etAddMonoNoise, etAntiAlias,
    etContrast, etFishEye, etGrayscale, etLightness, etDarkness,
    etSaturation, etSplitBlur, etGaussianBlur, etMosaic, etTwist,
    etSplitLight, etTile, etSpotLight, etTrace, etEmboss,
    etSolarize, etPosterize, etFlipHorizontal, etFlipVertical, etZoom,
    etCrop, etBlur, etSharpen, etSharpenEdge
  );

  TSBImageEffect = class(TObject)
  Private
    { Private declarations }
    FSourceBmp: TBitmap;
    FUsedBmp: TBitmap;
    FUseSource: Boolean;
    procedure SetSourceBmp(const Value: TBitmap);
    procedure SetUsedBmp(const Value: TBitmap);

    Procedure PicInvert(Var Src: TBitmap);
    Procedure AddColorNoise(Var Clip: TBitmap; Amount: Integer);
    procedure AddMonoNoise(Var Clip: TBitmap; Amount: Integer);
    Procedure AntiAliasRect(Var Clip: TBitmap; XOrigin, YOrigin, XFinal, YFinal: Integer);
	Procedure AntiAlias(Var Clip: TBitmap);
	Procedure Contrast(Var Clip: tbitmap; Amount: Integer);
    procedure FishEye(Var Bmp, Dst: TBitmap; Amount: Extended);
    Procedure GrayScale(Var Clip: TBitmap);
    Procedure Lightness(Var Clip: TBitmap; Amount: Integer);
    Procedure Darkness(Var Src: TBitmap; Amount: integer);
    procedure Saturation(Var Clip: TBitmap; Amount: Integer);
    procedure SmoothResize(Var Src, Dst: TBitmap);
    Procedure SmoothRotate(Var Src, Dst: TBitmap; cx, cy: Integer; Angle: Extended);
    procedure SplitBlur(Var Clip: TBitmap; Amount: integer);
    procedure GaussianBlur(Var Clip: TBitmap; Amount: integer);
    procedure Mosaic(Var Bm: TBitmap; Size: Integer);
    procedure Twist(Var Bmp, Dst: TBitmap; Amount: integer);
    Procedure Splitlight (Var Clip: TBitmap; Amount: Integer);
    procedure Tile(Var Src, Dst: TBitmap; Amount: Integer);
    procedure SpotLight (Var Src: TBitmap; Amount: Integer; Spot: TRect);
    procedure Trace (Var Src: TBitmap; Intensity: Integer);
    procedure Emboss(Var Bmp: TBitmap);
	procedure Solorize(Var Src, Dst: TBitmap; Amount: Integer);
	procedure Posterize(Var Src, Dst: TBitmap; Amount: Integer);
    procedure FlipHorizontal(Var Src, Dst: TBitmap);
    procedure FlipVertical(Var Src, Dst: TBitmap);
    procedure Rotate90(Var Src, Dst: TBitmap; Angle: Integer);
    Procedure Zoom(Var Src, Dst: TBitmap; Scale: Single; bAntiAlias: Boolean);
    Procedure ZoomXY(Var Src, Dst: TBitmap; ScaleX, ScaleY: Single; bAntiAlias: Boolean);
    Procedure Crop(Var Src, Dst: TBitmap; Bounds: TRect);
    Procedure Blur(Var Src, Dst: TBitmap);
    Procedure Sharpen(Var Src, Dst: TBitmap);
    Procedure SharpenEdge(Var Src, Dst: TBitmap);
    Procedure Brighten(Var Bmp: TBitmap);
    Procedure Spray(Var Src, Dst: TBitmap; Amount: Integer);


  Public
    { Public declarations }
    Constructor Create; //override;
    Destructor Destroy; override;

    Function  Effect_Invert          : TBitmap;
    Function  Effect_AddColorNoise   (Amount:Integer): TBitmap;
    Function  Effect_AddMonoNoise    (Amount:Integer): TBitmap;
    Function  Effect_AntiAlias       : TBitmap;
    Function  Effect_Contrast        (Amount:Integer): TBitmap;
    function  Effect_FishEye         (Amount:Integer): TBitmap;
    function  Effect_GrayScale       : TBitmap;
    function  Effect_Lightness       (Amount:Integer): TBitmap;
    function  Effect_Darkness        (Amount:Integer): TBitmap;
    function  Effect_Saturation      (Amount:Integer): TBitmap;
    function  Effect_SplitBlur       (Amount:Integer): TBitmap;
    function  Effect_GaussianBlur    (Amount:Integer): TBitmap;
    function  Effect_Mosaic          (Size:Integer): TBitmap;
    function  Effect_Twist           (Amount:Integer): TBitmap;
    function  Effect_Splitlight      (Amount:integer): TBitmap;
    function  Effect_Tile            (Amount: integer): TBitmap;
    function  Effect_SpotLight       (Amount: integer; Spot: TRect): TBitmap;
    function  Effect_Trace           (Amount: integer): TBitmap;
    function  Effect_Emboss: TBitmap;
    function  Effect_Solarize        (Amount: integer): TBitmap;
    function  Effect_Posterize       (Amount: integer): TBitmap;
  	Function  Effect_FlipHorizontal   : TBitmap;
    Function  Effect_FlipVertical    : TBitmap;
    Function  Effect_Rotate90        (Angle: Integer): TBitmap;
    Function  Effect_Zoom            (Scale: Single; AntiAlias: Boolean): TBitmap;
    Function  Effect_ZoomXY			 (ScaleX, ScaleY: Single; AntiAlias: Boolean): TBitmap;
    Function  Effect_Crop            (Bounds: TRect): TBitmap;
    Function  Effect_Blur            : TBitmap; overload;
    Function  Effect_Blur            (Src: TBitmap): TBitmap; overload;
    Function  Effect_Sharpen         : TBitmap; overload;
    Function  Effect_Sharpen         (Src: TBitmap): TBitmap; overload;
    Function  Effect_Rotate          (Angle: Integer; AntiAlias: Boolean): TBitmap;
    Function  Effect_SharpenEdge     : TBitmap;
    Function  Effect_Brighten        : TBitmap;
    Function  Effect_Spray           (Amount: Integer): TBitmap;
  published
    { Published declarations }
    Property SourceBmp: TBitmap read FSourceBmp write SetSourceBmp;
    Property UsedBmp: TBitmap Read FUsedBmp Write SetUsedBmp;
    Property UseSource: Boolean Read FUseSource Write FUseSource;
  End;




implementation





//****************************************************************************
{ TSBImageEffect }

Constructor TSBImageEffect.Create;
Begin
	//Inherited Create(AOwner);
  	FUseSource := True; //  ó Source ̹  
	FSourceBmp := TBitmap.Create;
    FUsedBmp := TBitmap.Create;
End;
Destructor TSBImageEffect.Destroy;
Begin
	FreeAndNil(FSourceBmp);
    FreeAndNil(FUsedBmp);
  	Inherited Destroy;
End;

//******************************************************************************
// Private Methods.
//******************************************************************************


//******************************************************************************
// Image Invert(:)
//******************************************************************************
Procedure TSBImageEffect.PicInvert(Var Src: TBitmap);
Var
    w,h,x,y: Integer;
    P: PByteArray;  // sysUtils.pas
Begin
    w := Src.Width;
    h := Src.Height;
    Src.PixelFormat := pf24bit;
    For y:=0 To H-1 do
    Begin
        p := Src.ScanLine[y];
        For x:=0 to W-1 do
        Begin
          p[x*3]:= Not p[x*3];    //R
          p[x*3+1] := Not p[x*3+1];//G
          p[x*3+2] := Not p[x*3+2];//B
        End;
    End;
End;

//******************************************************************************
// Adding Color Noise
//******************************************************************************
Procedure TSBImageEffect.AddColorNoise(Var Clip: TBitmap; Amount: Integer);
Var
    p0: PByteArray;
    x,y: Integer;
    r,g,b: Integer;
Begin
  For y := 0 to Clip.Height-1 Do
  Begin
		p0 := Clip.ScanLine [y];
    For x:=0 To Clip.Width-1 Do
    Begin
      	r := p0[x*3] + (Random(Amount) - (Amount shr 1));
      	g := p0[x*3+1] + (Random(Amount) - (Amount shr 1));
      	b := p0[x*3+2] + (Random(Amount) - (Amount shr 1));
      	p0[x*3] := IntToByte(r);
      	p0[x*3+1] := IntToByte(g);
      	p0[x*3+2] := IntToByte(b);
    End;
  End;
End;
//******************************************************************************
// Adding Mono noise
//******************************************************************************
Procedure TSBImageEffect.AddMonoNoise(Var Clip: TBitmap; Amount: Integer);
var
    p0: PByteArray;
    x,y,a: Integer;
    r,g,b: Integer;
begin
  for y:=0 to Clip.Height-1 do
  begin
    p0 := Clip.ScanLine[y];
    for x:=0 to Clip.Width-1 do
    begin
      a := Random(Amount) - (Amount shr 1);
      r := p0[x*3]+a;
      g := p0[x*3+1]+a;
      b := p0[x*3+2]+a;
      p0[x*3] := IntToByte(r);
      p0[x*3+1] := IntToByte(g);
      p0[x*3+2] := IntToByte(b);
    end;
  end;
end;
//******************************************************************************
// AntiAlias in Rect
//******************************************************************************
Procedure TSBImageEffect.AntiAliasRect(Var Clip: TBitmap; XOrigin, YOrigin, XFinal, YFinal: Integer);
Var
    Memo,x,y: Integer; (* Composantes primaires des points environnants *)
    p0,p1,p2: PByteArray;

begin
    If XFinal<XOrigin Then
    Begin
        Memo := XOrigin; XOrigin:=XFinal; XFinal:=Memo;
    End;  (* Inversion des valeurs   *)
    If YFinal<YOrigin Then
    Begin
        Memo := YOrigin; YOrigin:=YFinal; YFinal:=Memo;
    End;  (* si diffrence ngative*)
    XOrigin := max(1,XOrigin);
    YOrigin := max(1,YOrigin);
    XFinal:= min(Clip.Width-2, XFinal);
    YFinal := min(Clip.Height-2, YFinal);
    Clip.PixelFormat := pf24bit;

    For y:=YOrigin to YFinal do
    Begin
        p0 := Clip.ScanLine [y-1];
        p1 := Clip.scanline [y];
        p2 := Clip.ScanLine [y+1];
    For x:=XOrigin to XFinal do
    begin
        p1[x*3] := (p0[x*3]+p2[x*3]+p1[(x-1)*3]+p1[(x+1)*3]) Div 4;
        p1[x*3+1] := (p0[x*3+1]+p2[x*3+1]+p1[(x-1)*3+1]+p1[(x+1)*3+1]) Div 4;
        p1[x*3+2] := (p0[x*3+2]+p2[x*3+2]+p1[(x-1)*3+2]+p1[(x+1)*3+2]) Div 4;
    End;
   end;
end;
//******************************************************************************
// AntiAlias to TBitmap
//******************************************************************************
Procedure TSBImageEffect.AntiAlias(Var Clip: TBitmap);
Begin
	AntiAliasRect(Clip,0,0, Clip.Width, Clip.Height);
End;
//******************************************************************************
// Contrast (ϴ
//******************************************************************************
Procedure TSBImageEffect.Contrast(Var Clip: tbitmap; Amount: Integer);
var
    p0: PByteArray;
    rg,gg,bg,r,g,b: Integer;
    x,y: Integer;
Begin
    For y:=0 to clip.Height-1 do
    Begin
        p0 := Clip.ScanLine[y];
        For x:=0 to Clip.Width-1 do
        begin
            r := p0[x*3];
            g := p0[x*3+1];
            b := p0[x*3+2];
            rg := (Abs(127-r)*Amount) div 255;
            gg := (Abs(127-g)*Amount) div 255;
            bg := (Abs(127-b)*Amount) div 255;
            if r>127 Then r := r+rg Else r := r-rg;
            if g>127 Then g := g+gg Else g := g-gg;
            if b>127 Then b := b+bg Else b := b-bg;
            p0[x*3] := IntToByte(r);
            p0[x*3+1] := IntToByte(g);
            p0[x*3+2] := IntToByte(b);
        End;
    End;
end;
//******************************************************************************
// Fish Eye...
//******************************************************************************
procedure TSBImageEffect.FishEye(Var Bmp, Dst: TBitmap; Amount: Extended);
var
    xmid,ymid              : Single;
    fx,fy                  : Single;
    r1, r2                 : Single;
    ifx, ify               : integer;
    dx, dy                 : Single;
    rmax                   : Single;
    ty, tx                 : Integer;
    weight_x, weight_y     : Array[0..1] of Single;
    weight                 : Single;
    new_red, new_green     : Integer;
    new_blue               : Integer;
    total_red, total_green : Single;
    total_blue             : Single;
    ix, iy                 : Integer;
    sli, slo : PByteArray;
Begin
    xmid := Bmp.Width/2;
    ymid := Bmp.Height/2;
    rmax := Dst.Width * Amount;

    For ty := 0 to Dst.Height - 1 do
    Begin
        For tx := 0 to Dst.Width - 1 do
        Begin
            dx := tx - xmid;
            dy := ty - ymid;
            r1 := Sqrt(dx * dx + dy * dy);
            If r1 = 0 then
            begin
                fx := xmid;
                fy := ymid;
            End
            Else
            Begin
                r2 := rmax / 2 * (1 / (1 - r1/rmax) - 1);
                fx := dx * r2 / r1 + xmid;
                fy := dy * r2 / r1 + ymid;
            End;
            ify := Trunc(fy);
            ifx := Trunc(fx);
            // Calculate the weights.
            If fy >= 0  then
            Begin
                weight_y[1] := fy - ify;
                weight_y[0] := 1 - weight_y[1];
            End
            Else
            Begin
                weight_y[0] := -(fy - ify);
                weight_y[1] := 1 - weight_y[0];
            End;
            If fx >= 0 then
            Begin
                weight_x[1] := fx - ifx;
                weight_x[0] := 1 - weight_x[1];
            End
            Else
            Begin
                weight_x[0] := -(fx - ifx);
                Weight_x[1] := 1 - weight_x[0];
            End;

            If ifx < 0 Then
                ifx := Bmp.Width-1-(-ifx mod Bmp.Width)
            Else if ifx > Bmp.Width-1  Then
                ifx := ifx mod Bmp.Width;
            If ify < 0 Then
                ify := Bmp.Height-1-(-ify mod Bmp.Height)
            Else if ify > Bmp.Height-1 Then
                ify := ify mod Bmp.Height;

            total_red   := 0.0;
            total_green := 0.0;
            total_blue  := 0.0;

            For ix := 0 to 1 do
            Begin
                For iy := 0 to 1 do
                Begin
                    if ify + iy < Bmp.Height then
                        sli := Bmp.scanline[ify + iy]
                    Else
                        sli := Bmp.scanline[Bmp.Height - ify - iy];
                    If ifx + ix < Bmp.Width then
                    Begin
                        new_red := sli[(ifx + ix)*3];
                        new_green := sli[(ifx + ix)*3+1];
                        new_blue := sli[(ifx + ix)*3+2];
                    End
                    Else
                    Begin
                        new_red := sli[(Bmp.Width - ifx - ix)*3];
                        new_green := sli[(Bmp.Width - ifx - ix)*3+1];
                        new_blue := sli[(Bmp.Width - ifx - ix)*3+2];
                    End;
                    weight := weight_x[ix] * weight_y[iy];
                    total_red   := total_red   + new_red   * weight;
                    total_green := total_green + new_green * weight;
                    total_blue  := total_blue  + new_blue  * weight;
                End;
            End;
            slo := Dst.ScanLine[ty];
            slo[tx*3] := Round(total_red);
            slo[tx*3+1] := Round(total_green);
            slo[tx*3+2] := Round(total_blue);
        End;
    End;
end;
//******************************************************************************
// Grayscale...
//******************************************************************************
Procedure TSBImageEffect.GrayScale(Var Clip: TBitmap);
Var
    p0: PByteArray;
    Gray,x,y: Integer;
Begin
    For y:=0 to Clip.Height-1 do
    Begin
        p0 := Clip.ScanLine[y];
        For x:=0 to Clip.Width-1 do
        Begin
            Gray := Round(p0[x*3]*0.3+p0[x*3+1]*0.59+p0[x*3+2]*0.11);
            p0[x*3] := Gray;
            p0[x*3+1] := Gray;
            p0[x*3+2] := Gray;
        End;
    End;
end;
//******************************************************************************
// Lightness()
//******************************************************************************
Procedure TSBImageEffect.Lightness(Var Clip: TBitmap; Amount: Integer);
Var
    p0: PByteArray;
    r,g,b,x,y: Integer;
begin
    For y:=0 to clip.Height-1 do
    Begin
        p0 := Clip.ScanLine[y];
        For x:=0 to clip.Width-1 do
        Begin
            r := p0[x*3];
            g := p0[x*3+1];
            b := p0[x*3+2];
            p0[x*3] := IntToByte(r+((255-r)*Amount)div 255);
            p0[x*3+1] := IntToByte(g+((255-g)*Amount)div 255);
            p0[x*3+2] := IntToByte(b+((255-b)*Amount)div 255);
        End;
    End;
end;
//******************************************************************************
// Darkness(Ӱ)
//******************************************************************************
Procedure TSBImageEffect.Darkness(Var Src: TBitmap; Amount: integer);
Var
    p0: PByteArray;
    r,g,b,x,y: Integer;
begin
    Src.pixelformat:=pf24bit;
    For y:=0 To src.Height-1 do
    Begin
        p0 := Src.ScanLine[y];
        For x:=0 To Src.Width-1 do
        Begin
            r := p0[x*3];
            g := p0[x*3+1];
            b := p0[x*3+2];
            p0[x*3] := IntToByte(r-((r)*Amount)div 255);
            p0[x*3+1] := IntToByte(g-((g)*Amount)div 255);
            p0[x*3+2] := IntToByte(b-((b)*Amount)div 255);
       End;
    End;
end;
//******************************************************************************
// ä Saturation    ( 3Ӽ() ϳ  (ȥյ)
//******************************************************************************
procedure TSBImageEffect.Saturation(Var Clip: TBitmap; Amount: Integer);
Var
    p0: PByteArray;
    Gray,r,g,b,x,y: Integer;
Begin
    For y:=0 to clip.Height-1 do
    Begin
        p0 := Clip.ScanLine[y];
        For x:=0 to Clip.Width-1 do
        Begin
            r := p0[x*3];
            g := p0[x*3+1];
            b := p0[x*3+2];
            Gray := (r+g+b)div 3;
            p0[x*3] := IntToByte(Gray+(((r-Gray)*Amount)div 255));
            p0[x*3+1] := IntToByte(Gray+(((g-Gray)*Amount)div 255));
            p0[x*3+2] := IntToByte(Gray+(((b-Gray)*Amount)div 255));
        End;
    End;
end;
//******************************************************************************
// Resize Smoothly ε巴 ũ ϱ
//******************************************************************************
procedure TSBImageEffect.SmoothResize(Var Src, Dst: TBitmap);
var
    x,y,xP,yP,
    yP2,xP2:     Integer;
    Read,Read2:  PByteArray;
    t,z,z2,iz2:  Integer;
    pc: PByteArray;
    w1,w2,w3,w4: Integer;
    Col1r,col1g,col1b,Col2r,col2g,col2b: Byte;
Begin
    xP2 := ((src.Width-1) shl 15) div Dst.Width;
    yP2 := ((src.Height-1) shl 15) div Dst.Height;
    yP := 0;
    For y:=0 To Dst.Height-1 do
    Begin
        xP := 0;
        Read := Src.ScanLine[yP shr 15];
        If yP shr 16<src.Height-1 then
            Read2 := Src.ScanLine [yP shr 15+1]
        Else
            Read2 := Src.ScanLine [yP shr 15];
        pc := Dst.scanline[y];
        z2 := yP and $7FFF;
        iz2 := $8000-z2;
        For x:=0 To Dst.Width-1 do
        Begin
            t := xP shr 15;
            Col1r := Read[t*3];
            Col1g := Read[t*3+1];
            Col1b := Read[t*3+2];
            Col2r := Read2[t*3];
            Col2g := Read2[t*3+1];
            Col2b := Read2[t*3+2];
            z := xP and $7FFF;
            w2 := (z*iz2)shr 15;
            w1 := iz2-w2;
            w4 := (z*z2)shr 15;
            w3 := z2-w4;
            pc[x*3+2]:=
              (Col1b*w1+Read[(t+1)*3+2]*w2 + Col2b*w3+Read2[(t+1)*3+2]*w4)shr 15;
            pc[x*3+1]:=
              (Col1g*w1+Read[(t+1)*3+1]*w2 + Col2g*w3+Read2[(t+1)*3+1]*w4)shr 15;
            pc[x*3]:=
              (Col1r*w1+Read2[(t+1)*3]*w2 + Col2r*w3+Read2[(t+1)*3]*w4)shr 15;
            Inc(xP,xP2);
        End;
        Inc(yP,yP2);
    End;
end;
//******************************************************************************
//  Ratating smoothly (ε巴 ȸŰ)
//******************************************************************************
Procedure TSBImageEffect.SmoothRotate(Var Src, Dst: TBitmap; cx, cy: Integer; Angle: Extended);
Type
 TFColor  = Record b,g,r:Byte End;
Var
    Top, Bottom, Left, Right,
    eww,nsw,
    fx,fy,
    wx,wy:    Extended;
    cAngle,
    sAngle:   Double;
    xDiff,
    yDiff,
    ifx,ify,
    px,py,
    ix,iy,
    x,y:      Integer;
    nw,ne,
    sw,se:    TFColor;
    P1,P2,P3: PByteArray;
Begin
    Angle := -Angle*Pi/180;
    sAngle := Sin(Angle);
    cAngle := Cos(Angle);
    xDiff := (Dst.Width-Src.Width)div 2;
    yDiff := (Dst.Height-Src.Height)div 2;
    For y:=0 to Dst.Height-1 do
    Begin
        P3 := Dst.ScanLine[y];
        py := 2*(y-cy)+1;
        For x:=0 to Dst.Width-1 do
        Begin
            px:=2*(x-cx)+1;
            fx:=(((px*cAngle-py*sAngle)-1)/ 2+cx)-xDiff;
            fy:=(((px*sAngle+py*cAngle)-1)/ 2+cy)-yDiff;
            ifx:=Round(fx);
            ify:=Round(fy);

            If (ifx>-1) And (ifx<Src.Width) And (ify>-1) And (ify<Src.Height) Then
            Begin
                eww := fx-ifx;
                nsw := fy-ify;
                iy := TrimInt(ify+1,0,Src.Height-1);
                ix := TrimInt(ifx+1,0,Src.Width-1);
                P1 := Src.ScanLine[ify];
                P2 := Src.ScanLine[iy];
                nw.r := P1[ifx*3];
                nw.g := P1[ifx*3+1];
                nw.b := P1[ifx*3+2];
                ne.r := P1[ix*3];
                ne.g := P1[ix*3+1];
                ne.b := P1[ix*3+2];
                sw.r := P2[ifx*3];
                sw.g := P2[ifx*3+1];
                sw.b := P2[ifx*3+2];
                se.r := P2[ix*3];
                se.g := P2[ix*3+1];
                se.b := P2[ix*3+2];

                Top := nw.b+eww*(ne.b-nw.b);
                Bottom := sw.b+eww*(se.b-sw.b);
                P3[x*3+2] := IntToByte(Round(Top+nsw*(Bottom-Top)));

                Top := nw.g+eww*(ne.g-nw.g);
                Bottom := sw.g+eww*(se.g-sw.g);
                P3[x*3+1] := IntToByte(Round(Top+nsw*(Bottom-Top)));

                Top := nw.r+eww*(ne.r-nw.r);
                Bottom := sw.r+eww*(se.r-sw.r);
                P3[x*3] := IntToByte(Round(Top+nsw*(Bottom-Top)));
            End; // of If (ifx>-1) And (ifx<Src.Width)... 
        End; // of For x:=0 to Dst.Width-1 do
    End; // of For y:=0 to Dst.Height-1 do
end;
//******************************************************************************
// split blur...
//******************************************************************************
procedure TSBImageEffect.SplitBlur(Var Clip: TBitmap; Amount: integer);
Var
    p0,p1,p2: PByteArray;
    cx,x,y: Integer;
    Buf: Array[0..3,0..2] of Byte;
Begin
    If Amount=0 then Exit;
    For y:=0 to Clip.Height-1 do
    Begin
        p0 := Clip.ScanLine[y];
        If y-Amount<0         Then p1 := Clip.Scanline[y]
        Else {y-Amount>0}          p1 := Clip.ScanLine[y-Amount];
        If y+Amount<Clip.Height    then p2 := Clip.ScanLine[y+Amount]
        Else {y+Amount>=Height}    p2 := Clip.ScanLine[clip.Height-y];

        For x:=0 To Clip.Width-1 do
        Begin
            If x-Amount<0     then cx := x
            Else {x-Amount>0}      cx := x-Amount;
            Buf[0,0] := p1[cx*3];
            Buf[0,1] := p1[cx*3+1];
            Buf[0,2] := p1[cx*3+2];
            Buf[1,0] := p2[cx*3];
            Buf[1,1] := p2[cx*3+1];
            Buf[1,2] := p2[cx*3+2];
            if x+Amount<Clip.Width     then cx := x+Amount
            else {x+Amount>=Width}     cx := Clip.Width-x;
            Buf[2,0] := p1[cx*3];
            Buf[2,1] := p1[cx*3+1];
            Buf[2,2] := p1[cx*3+2];
            Buf[3,0] := p2[cx*3];
            Buf[3,1] := p2[cx*3+1];
            Buf[3,2] := p2[cx*3+2];
            p0[x*3] := (Buf[0,0]+Buf[1,0]+Buf[2,0]+Buf[3,0]) shr 2;
            p0[x*3+1] := (Buf[0,1]+Buf[1,1]+Buf[2,1]+Buf[3,1]) shr 2;
            p0[x*3+2] := (Buf[0,2]+Buf[1,2]+Buf[2,2]+Buf[3,2]) shr 2;
        End;
    End;
end;
//******************************************************************************
// GaussianBlur is what splitblur is applied three times.
//******************************************************************************
procedure TSBImageEffect.GaussianBlur(Var Clip: TBitmap; Amount: integer);
Var
    i: Integer;
Begin
  For i:=Amount Downto 0 do
	  SplitBlur(Clip,3);
End;
//******************************************************************************
// Mosaic effect.
//******************************************************************************
procedure TSBImageEffect.Mosaic(Var Bm: TBitmap; Size: Integer);
var
    x,y,i,j: Integer;
    p1,p2: PByteArray;
    r,g,b: Byte;
Begin
    y:=0;
    Repeat
        p1:=bm.scanline[y];
        x:=0;
        Repeat
            j:=1;
            Repeat
                p2:=bm.scanline[y];
                x:=0;
                Repeat
                    r:=p1[x*3];
                    g:=p1[x*3+1];
                    b:=p1[x*3+2];
                    i:=1;
                    Repeat
                        p2[x*3]:=r;
                        p2[x*3+1]:=g;
                        p2[x*3+2]:=b;
                        inc(x);
                        inc(i);
                    Until (x>=bm.width) or (i>size);
                Until x>=bm.width; // of Repeat.
                inc(j);
                inc(y);
            Until (y>=bm.height) or (j>size);
        Until (y>=bm.height) or (x>=bm.width);
    until y>=bm.height;
end;
//******************************************************************************
// twist... Ʋ
//******************************************************************************
procedure TSBImageEffect.Twist(Var Bmp, Dst: TBitmap; Amount: integer);
Var
    fxmid, fymid : Single;
    txmid, tymid : Single;
    fx,fy : Single;
    tx2, ty2 : Single;
    r : Single;
    theta : Single;
    ifx, ify : integer;
    dx, dy : Single;
    OFFSET : Single;
    ty, tx             : Integer;
    weight_x, weight_y     : Array[0..1] of Single;
    weight                 : Single;
    new_red, new_green     : Integer;
    new_blue               : Integer;
    total_red, total_green : Single;
    total_blue             : Single;
    ix, iy                 : Integer;
    sli, slo : PBytearray;

    Function  ArcTan2(xt,yt : Single): Single;
    Begin
    	If xt = 0 then
            If yt > 0 then
                Result := Pi/2
            Else
            	Result := -(Pi/2)
        Else
        Begin
            Result := ArcTan(yt/xt);
            if xt < 0 then
            	Result := Pi + ArcTan(yt/xt);
        End;
    End;

begin
    OFFSET := -(Pi/2);
    dx := Bmp.Width - 1;
    dy := Bmp.Height - 1;
    r := Sqrt(dx * dx + dy * dy);
    tx2 := r;
    ty2 := r;
    txmid := (Bmp.Width-1)/2;    //Adjust these to move center of rotation
    tymid := (Bmp.Height-1)/2;   //Adjust these to move ......
    fxmid := (Bmp.Width-1)/2;
    fymid := (Bmp.Height-1)/2;
    If tx2 >= Bmp.Width     then    tx2 := Bmp.Width-1;
    If ty2 >= Bmp.Height    then    ty2 := Bmp.Height-1;

    For ty := 0 to Round(ty2) do
    Begin
        for tx := 0 to Round(tx2) do
        Begin
            dx := tx - txmid;
            dy := ty - tymid;
            r := Sqrt(dx * dx + dy * dy);
            If r = 0 then
            Begin
                fx := 0;
                fy := 0;
            End
            Else
            Begin
                theta := ArcTan2(dx,dy) - r/Amount - OFFSET;
                fx := r * Cos(theta);
                fy := r * Sin(theta);
            End;
            fx := fx + fxmid;
            fy := fy + fymid;

            ify := Trunc(fy);
            ifx := Trunc(fx);
                      // Calculate the weights.
            If fy >= 0  then
            Begin
                weight_y[1] := fy - ify;
                weight_y[0] := 1 - weight_y[1];
            End Else
            Begin
                weight_y[0] := -(fy - ify);
                weight_y[1] := 1 - weight_y[0];
            End;
            If fx >= 0 then
            Begin
                weight_x[1] := fx - ifx;
                weight_x[0] := 1 - weight_x[1];
            End
            Else
            Begin
                weight_x[0] := -(fx - ifx);
                Weight_x[1] := 1 - weight_x[0];
            End;

            If ifx < 0 then
                ifx := Bmp.Width-1-(-ifx mod Bmp.Width)
            Else if ifx > Bmp.Width-1  then
                ifx := ifx mod Bmp.Width;
            If ify < 0 then
                ify := Bmp.Height-1-(-ify mod Bmp.Height)
            Else if ify > Bmp.Height-1 then
                ify := ify mod Bmp.Height;

            total_red   := 0.0;
            total_green := 0.0;
            total_blue  := 0.0;
            For ix := 0 to 1 do
            Begin
                For iy := 0 to 1 do
                Begin
                    If ify + iy < Bmp.Height then
                        sli := Bmp.scanline[ify + iy]
                    Else
                        sli := Bmp.scanline[Bmp.Height - ify - iy];
                    If ifx + ix < Bmp.Width then
                    Begin
                        new_red := sli[(ifx + ix)*3];
                        new_green := sli[(ifx + ix)*3+1];
                        new_blue := sli[(ifx + ix)*3+2];
                    End
                    Else
                    Begin
                        new_red := sli[(Bmp.Width - ifx - ix)*3];
                        new_green := sli[(Bmp.Width - ifx - ix)*3+1];
                        new_blue := sli[(Bmp.Width - ifx - ix)*3+2];
                    End;
                    weight := weight_x[ix] * weight_y[iy];
                    total_red   := total_red   + new_red   * weight;
                    total_green := total_green + new_green * weight;
                    total_blue  := total_blue  + new_blue  * weight;
                End; // of for iy := 0 to...
            End; // of ix := 0 ...
            slo := Dst.scanline[ty];
            slo[tx*3] := Round(total_red);
            slo[tx*3+1] := Round(total_green);
            slo[tx*3+2] := Round(total_blue);
        End; // of for tx := 0 to Round(tx2) do
    End;
end;
//******************************************************************************
// Splitlight
//******************************************************************************
Procedure TSBImageEffect.Splitlight (Var Clip: TBitmap; Amount: Integer);
Var
    x,y,i: Integer;
    p1: PByteArray;

    Function SinPixs(a: Integer): Integer;
    Begin
        Result:= Variant(sin(a/255*pi/2)*255);
    End;
Begin
    For i:=1 to Amount do
        For y:=0 to Clip.height-1 do
        Begin
            p1:=clip.ScanLine[y];
            For x:=0 to clip.width-1 do
            Begin
                p1[x*3] := Sinpixs(p1[x*3]);
                p1[x*3+1] := Sinpixs(p1[x*3+1]);
                p1[x*3+2] := Sinpixs(p1[x*3+2]);
            End;
        End; // of for y := 0 ...
end;
//******************************************************************************
// Tiles:
// ̹ 簢 Ÿ   ϴ.
//   ä ɼǿ ϴ  äϴ
//******************************************************************************
procedure TSBImageEffect.Tile(Var Src, Dst: TBitmap; Amount: Integer);
var
    w,h,w2,h2,i,j: Integer;
    Bm: TBitmap;
begin
    w := Src.Width;
    h := Src.Height;
    Dst.Width := w;
    Dst.Height := h;
    Dst.Canvas.Draw(0,0,src);
    if (Amount<=0) or ((w div Amount)<5)or ((h div Amount)<5) Then Exit;
    h2 := h div Amount;
    w2 := w div Amount;
    Bm := TBitmap.create;
    Bm.Width:=w2;
    Bm.Height:=h2;
    Bm.PixelFormat :=pf24bit;
    SmoothResize(Src,Bm);
    For j:=0 to Amount-1 do
        For i:=0 to Amount-1 do
            Dst.Canvas.Draw (i*w2,j*h2,Bm);
    Bm.Free;
end;
//******************************************************************************
// spotlight
//******************************************************************************
procedure TSBImageEffect.SpotLight (Var Src: TBitmap; Amount: Integer; Spot: TRect);
Var Bm: TBitmap;
    w,h: Integer;
begin
    Darkness(Src, Amount);
    W := Src.Width;
    H := Src.Height ;
    Bm := TBitmap.Create;
    Bm.Width := w;
    Bm.Height := h;
    Bm.Canvas.Brush.color := clBlack;
    Bm.Canvas.FillRect (Rect(0,0,w,h));
    Bm.Canvas.brush.Color := clwhite;
    Bm.Canvas.Ellipse (Spot.Left,Spot.Top, Spot.Right, Spot.Bottom);
    Bm.TransParent:=true;
    Bm.TransParentColor := clwhite;
    Src.Canvas.Draw (0,0,bm);
    Bm.Free;
end;
//******************************************************************************
// Trace contour :
//  ٲ κп  
// ׸    ־  巯 մϴ
//******************************************************************************
procedure TSBImageEffect.Trace (Var Src: TBitmap; Intensity: Integer);
Var
    x,y,i : integer;
    P1,P2,P3,P4 : PByteArray;
    tb,TraceB:byte;
    hasb:boolean;
    bitmap: TBitmap;
Begin
    Bitmap:= TBitmap.Create;
    Bitmap.Width := Src.Width;
    Bitmap.Height := Src.Height;
    Bitmap.Canvas.draw(0,0,src);
    Bitmap.PixelFormat := pf8bit;
    Src.PixelFormat := pf24bit;
    hasb := False;
    TraceB := $00;
    For i:=1 to Intensity do
    Begin
			For y := 0 to BitMap.height -2 do
        Begin
            P1 := BitMap.ScanLine[y];
            P2 := BitMap.ScanLine[y+1];
            P3 := Src.ScanLine[y];
            P4 := Src.ScanLine[y+1];
            x := 0;

            Repeat
            	If p1[x]<>p1[x+1] then
                Begin
                    If not hasb then
                    Begin
                        tb:=p1[x+1];
                        hasb:=true;
                        p3[x*3]:=TraceB;
                        p3[x*3+1]:=TraceB;
                        p3[x*3+2]:=TraceB;
                    End
                    Else
                    Begin
                      	If p1[x]<>tb Then
                      	Begin
                          	p3[x*3]:=TraceB;
                          	p3[x*3+1]:=TraceB;
                          	p3[x*3+2]:=TraceB;
	                    	End
                    	Else
                    	Begin
                        	p3[(x+1)*3]:=TraceB;
                        	p3[(x+1)*3+1]:=TraceB;
                        	p3[(x+1)*3+1]:=TraceB;
                    	End;
                	End;
            	End;
                If p1[x]<>p2[x] then
                Begin
                    If not hasb then
                    Begin
                       tb:=p2[x];
                       hasb:=true;
                       p3[x*3]:=TraceB;
                       p3[x*3+1]:=TraceB;
                       p3[x*3+2]:=TraceB;
                    End
                    Else
                    Begin
                        If p1[x]<>tb then
                        Begin
                            p3[x*3]:=TraceB;
                            p3[x*3+1]:=TraceB;
                            p3[x*3+2]:=TraceB;
                        End
                        Else
                        Begin  { p1[x] = tb }
                            p4[x*3]:=TraceB;
                            p4[x*3+1]:=TraceB;
                            p4[x*3+2]:=TraceB;
                        End;
                    End;
                End;
                Inc(x);
            Until x>=(BitMap.width -2);
        End;
        If i>1 then
        For y := BitMap.Height -1 Downto 1 do
        Begin
            P1 := BitMap.ScanLine[y];
            P2 := BitMap.ScanLine[y-1];
            P3 := Src.scanLine[y];
            P4 := Src.scanLine [y-1];
            x := Bitmap.Width-1;
            Repeat
                If p1[x]<>p1[x-1] then
                Begin
                	If Not hasb then
                    Begin
                        tb := p1[x-1];
                        hasb := true;
                        p3[x*3] := TraceB;
                        p3[x*3+1] := TraceB;
                        p3[x*3+2] := TraceB;
                    End
                    Else
                    Begin
                        If p1[x]<>tb then
                        Begin
                            p3[x*3] := TraceB;
                            p3[x*3+1] := TraceB;
                            p3[x*3+2] := TraceB;
                        End
                        Else
                        Begin
                            p3[(x-1)*3] := TraceB;
                            p3[(x-1)*3+1] := TraceB;
                            p3[(x-1)*3+2] := TraceB;
                        End;
                    End;
                End;
                If p1[x]<>p2[x] then
                Begin
                    If Not hasb then
                    Begin
                        tb := p2[x];
                        hasb := true;
                        p3[x*3] := TraceB;
                        p3[x*3+1] := TraceB;
                        p3[x*3+2] := TraceB;
                    End
                    Else
                    Begin
                        If p1[x]<>tb then
                        Begin
                            p3[x*3] := TraceB;
                            p3[x*3+1] := TraceB;
                            p3[x*3+2] := TraceB;
                        End
                        Else
                        Begin
                            p4[x*3] := TraceB;
                            p4[x*3+1] := TraceB;
                            p4[x*3+2] := TraceB;
                        End;
                    End;
                End;
                dec(x);
            Until x<=1;
        End;
    End;
    Bitmap.Free;
End;
//******************************************************************************
// Emboss - ̹ 簢    ݴϴ.
//******************************************************************************
procedure TSBImageEffect.Emboss(Var Bmp: TBitmap);
Var
	x,y:   Integer;
	p1,p2: PByteArray;
Begin
  	For y:=0 to Bmp.Height-2 do
  	Begin
    	p1 := bmp.ScanLine[y];
    	p2 := bmp.ScanLine[y+1];
        For x:=0 to Bmp.Width-4 do
        Begin
            p1[x*3] := (p1[x*3]+(p2[(x+3)*3] xor $FF))shr 1;
            p1[x*3+1] := (p1[x*3+1]+(p2[(x+3)*3+1] xor $FF))shr 1;
            p1[x*3+2] := (p1[x*3+2]+(p2[(x+3)*3+2] xor $FF))shr 1;
        End;
  	End;

end;
//******************************************************************************
// Solarize
// ο κ ⸦   ȿ ݴϴ.
//******************************************************************************
procedure TSBImageEffect.Solorize(Var Src, Dst: TBitmap; Amount: Integer);
var
	w,h,x,y: Integer;
    ps,pd: PByteArray;
    c: Integer;
begin
    w := Src.Width;
    h := Src.Height;
    Src.PixelFormat := pf24bit;
    Dst.PixelFormat := pf24bit;
    for y:=0 to h-1 do
    begin
        ps := Src.ScanLine[y];
        pd := Dst.ScanLine[y];
        for x := 0 to w-1 do
        begin
            c := (ps[x*3]+ps[x*3+1]+ps[x*3+2]) div 3;
            if c>amount then begin
                pd[x*3] := 255-ps[x*3];
                pd[x*3+1] := 255-ps[x*3+1];
                pd[x*3+2] := 255-ps[x*3+2];
            end
            else begin
                pd[x*3] := ps[x*3];
                pd[x*3+1] := ps[x*3+1];
                pd[x*3+2] := ps[x*3+2];
            end;
        end;
    end;
end;
//******************************************************************************
// Posterize - ̰ ä Ʈ ϴ ̴.
// ä տ ߴµ ׸ RGB  и   
// ׸ ǹѴ. ƮĮ  ü Ʈ 24Ʈ̹Ƿ ä Ʈ
// 8Ʈ̴. ä Ʈ 1 7   ִµ, ä Ʈ
// ̸ 翬   پ.
//******************************************************************************
procedure TSBImageEffect.Posterize(Var Src, Dst: TBitmap; Amount: Integer);
var
	w,h,x,y: Integer;
  ps,pd: PByteArray;
Begin
    w := Src.Width;
    h := Src.Height;
    Src.PixelFormat := pf24bit;
  	Dst.PixelFormat := pf24bit;
  	For y:=0 to h-1 do
    Begin
   		ps := Src.ScanLine[y];
   		pd := Dst.ScanLine[y];
   		For x:=0 to w-1 do
   		Begin
            pd[x*3] := Round(ps[x*3]/amount)*amount;
            pd[x*3+1] := Round(ps[x*3+1]/amount)*amount;
            pd[x*3+2] := Round(ps[x*3+2]/amount)*amount;
    	End;
   	End;
end;


//******************************************************************************
//
// Public method.
//
//******************************************************************************


//****************************************************************************
// Invert source bitmap ()
//****************************************************************************
Function TSBImageEffect.Effect_Invert: TBitmap;
Begin
	Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
	  Result.Assign(FSourceBmp)
  Else
  	Result.Assign(FUsedBmp);

  PicInvert(Result); // call Invert method.

  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Add color noise as amount... RGB   Ѵ.
//****************************************************************************
Function  TSBImageEffect.Effect_AddColorNoise (Amount: Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  AddColorNoise (Result, Amount);

  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// Add mono Noise with amount. RGB   Ѵ.
//****************************************************************************
Function  TSBImageEffect.Effect_AddMonoNoise (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  AddMonoNoise (Result, Amount);

  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// AntiAlias...
//****************************************************************************
Function  TSBImageEffect.Effect_AntiAlias: TBitmap;
Begin
  Result := TBitmap.Create;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	AntiAlias (Result);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Contrast...  (Luminance) ...
//****************************************************************************
Function  TSBImageEffect.Effect_Contrast (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  Contrast (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// FishEye
//****************************************************************************
Function  TSBImageEffect.Effect_FishEye (Amount:Integer): TBitmap;
Var
	Bmp:TBitmap;
Begin
  Bmp := TBitmap.Create;
  Bmp.PixelFormat := pf24bit;
  If FUseSource Then
    Bmp.Assign(FSourceBmp)
  Else
    Bmp.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (Bmp);

  FishEye (Bmp,Result,Amount);

  Bmp.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Grayscale...
//****************************************************************************
Function  TSBImageEffect.Effect_GrayScale: TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  GrayScale(Result);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Lightness ...
//****************************************************************************
Function  TSBImageEffect.Effect_Lightness (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	Lightness (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Darkness Ӱ...
//****************************************************************************
Function  TSBImageEffect.Effect_Darkness (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	Darkness (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Saturation ä
//****************************************************************************
Function  TSBImageEffect.Effect_Saturation (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	Saturation (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// SplitBlur
//****************************************************************************
Function  TSBImageEffect.Effect_SplitBlur (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

	SplitBlur (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// GaussianBlur. ̹ 콺̶ Ҹ а ̿Ͽ blur
// մϴ. blur blur more  ȿ   ִ Դϴ.
//****************************************************************************
Function  TSBImageEffect.Effect_GaussianBlur (Amount:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	GaussianBlur (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Mosaic - ̹ Ÿϸ ߶ ǥմϴ.
//****************************************************************************
Function  TSBImageEffect.Effect_Mosaic (Size:Integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

 	Mosaic (Result, Size);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Twist - Ʋ.
//****************************************************************************
Function  TSBImageEffect.Effect_Twist (Amount:Integer): TBitmap;
Var
	B1: TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);

  Twist (B1, Result, Amount);

  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// Trace...    ߴ´
//****************************************************************************
Function  TSBImageEffect.Effect_Trace (Amount: integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  Trace (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Split light
//****************************************************************************
Function  TSBImageEffect.Effect_Splitlight (Amount:integer): TBitmap;
Begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  If FUseSource Then
    Result.Assign(FSourceBmp)
  Else
    Result.Assign(FUsedBmp);

  Splitlight (Result, Amount);
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Tile - Ÿϰ ȭ.
//****************************************************************************
Function  TSBImageEffect.Effect_Tile (Amount: integer): TBitmap;
Var
	B1: TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);

  Tile (B1, Result, Amount);

  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// SpotLight
//****************************************************************************
Function  TSBImageEffect.Effect_SpotLight (Amount: integer; Spot: TRect): TBitmap;
Var
	B1: TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);

  SpotLight (Result, Amount, Spot);

  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Emboss - ̹  踦   κ Ű ü ȿ
// ϴ. ַ 3D üȿ  ߰ܰ迡 Ȱ˴ϴ.
//****************************************************************************
Function  TSBImageEffect.Effect_Emboss: TBitmap;
Var
	B1:TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);

  Emboss (Result);

  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Solarize...  ο κ ⸦   ȿ ݴϴ
//****************************************************************************
Function  TSBImageEffect.Effect_Solarize (Amount: integer): TBitmap;
Var
	B1: TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);
  Solorize (B1, Result, Amount);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Posterize
//****************************************************************************
Function  TSBImageEffect.Effect_Posterize (Amount: integer): TBitmap;
Var
	B1:TBitmap;
Begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign (B1);
  Posterize (B1, Result, Amount);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Set Source Bitmap FSourceBmp.
//****************************************************************************
procedure TSBImageEffect.SetSourceBmp(const Value: TBitmap);
begin
  FSourceBmp.Assign( Value );
  FUsedBmp.Assign( Value);
end;
//****************************************************************************
// Flip - Horizontal. ̹ η ´.(reverse) Mirrorȿ
//****************************************************************************
procedure TSBImageEffect.FlipHorizontal(var Src, Dst: TBitmap);
Var
	x, y: integer;
  P, P1: PByteArray;  // sysUtils.pas
begin
	Dst.Width := Src.Width;
  Dst.Height := Src.Height;
  For y := 0 To Src.Height -1 Do
  Begin
  	P := Src.ScanLine[y];
    P1 := Dst.ScanLine[y];
		For x := 0 To Src.Width - 1 Do
    Begin
    	P1[(Dst.Width-1-x)*3  ] := P[x*3  ];
        P1[(Dst.Width-1-x)*3+1] := P[x*3+1];
        P1[(Dst.Width-1-x)*3+2] := P[x*3+2];
    End;
  End;
end;
//****************************************************************************
// Flip - Vertical - ̹ η ´. Mirrorȿ
//****************************************************************************
procedure TSBImageEffect.FlipVertical(var Src, Dst: TBitmap);
Var
	x, y: integer;
  P, P1: PByteArray;  // sysUtils.pas
begin
	Dst.Width := Src.Width;
  Dst.Height := Src.Height;
  For y := 0 To Src.Height -1 Do
  Begin
  	P := Src.ScanLine[y];
    P1 := Dst.ScanLine[Src.Height-1-y];
		For x := 0 To Src.Width - 1 Do
    Begin
    	P1[x*3  ] := P[x*3  ];
        P1[x*3+1] := P[x*3+1];
        P1[x*3+2] := P[x*3+2];
    End;
  End;
end;
//****************************************************************************
// Flip-Horizontal:  mirroring.
//****************************************************************************
Function TSBImageEffect.Effect_FlipHorizontal: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.Assign(B1);
  FlipHorizontal(B1, Result);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Flip-Vertical -  mirroring.
//****************************************************************************
Function TSBImageEffect.Effect_FlipVertical: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.Assign(B1);
  FlipVertical(B1, Result);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Rotate as Angle (90, 180, 360)
//****************************************************************************
function TSBImageEffect.Effect_Rotate90(Angle: Integer): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
	Rotate90(B1, Result, Angle);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Rotate as Angle (90, 180, 360)
//****************************************************************************
procedure TSBImageEffect.Rotate90(var Src, Dst: TBitmap; Angle: Integer);
Var
	x, y: integer;
  P, P1: PByteArray;  // sysUtils.pas
begin
  Case Angle Of
      0, 360:
          Dst.Assign(Src);
      90:
      Begin
          Dst.Width := Src.Height;
          Dst.Height := Src.Width;
          For y := 0 To Src.Height -1 Do
          Begin
              P := Src.ScanLine[y];
              For x := 0 To Src.Width-1 Do
              Begin
                  P1 := Dst.ScanLine[x];
                  P1[(Dst.Width-1-y)*3  ] := P[x*3];
                  P1[(Dst.Width-1-y)*3+1] := P[x*3+1];
                  P1[(Dst.Width-1-y)*3+2] := P[x*3+2];
              End; // of for x.
          End;
      End;
      180:
      Begin
          Dst.Width := Src.Width;
          Dst.Height := Src.Height;
          For y := 0 To Src.Height -1 Do
          Begin
              P := Src.ScanLine[y];
              P1 := Dst.ScanLine[Src.Height-1-y];
              For x := 0 To Src.Width-1 Do
              Begin
                  P1[(Dst.Width-1-x)*3  ] := P[x*3];
                  P1[(Dst.Width-1-x)*3+1] := P[x*3+1];
                  P1[(Dst.Width-1-x)*3+2] := P[x*3+2];
              End;
          End;
      End;
      270:
      Begin
          Dst.Width := Src.Height;
          Dst.Height := Src.Width;
          For y := 0 To Src.Height -1 Do
          Begin
              P := Src.ScanLine[y];
              For x := 0 To Src.Width-1 Do
              Begin
                  P1 := Dst.ScanLine[Dst.Height-1-x];
                  P1[y*3  ] := P[x*3];
                  P1[y*3+1] := P[x*3+1];
                  P1[y*3+2] := P[x*3+2];
              End;
          End;
      End;
  End;
end;
//****************************************************************************
// Zoom In / Out ȿ ش.
//****************************************************************************
Function TSBImageEffect.Effect_Zoom(Scale: Single; AntiAlias: Boolean): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign(B1);
  Zoom(B1, Result, Scale, AntiAlias);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// Zoom 
// Scale: (Percentage)
// bAntiAlias: antialias 뿩
//****************************************************************************
Procedure TSBImageEffect.Zoom(Var Src, Dst: TBitmap; Scale: Single; bAntiAlias: Boolean);
Var
  W, H: Integer;
Begin
	W := Round(Src.Width * Scale / 100);
  H := Round(Src.Height * Scale / 100);
  Dst.Width := W;
  Dst.Height := H;
	Dst.Canvas.StretchDraw(Rect(0,0,W,H), Src);
  If (bAntiAlias) Then
  	AntiAlias(Dst);
end;
//****************************************************************************
// Cropping. Source  Ư Bounds  ߶ Destination  Ѵ.
//****************************************************************************
procedure TSBImageEffect.Crop(var Src, Dst: TBitmap; Bounds: TRect);
Var
	rClient: TRect;
begin
	rClient := Rect(0, 0, Bounds.Right-Bounds.Left, Bounds.Bottom-Bounds.Top);
	Dst.Width := rClient.Right;  // set width.
  Dst.Height := rClient.Bottom;	// set height
	Dst.Canvas.CopyRect(rClient, Src.Canvas, Bounds);
end;
//****************************************************************************
// public: Effect_Crop
//****************************************************************************
function TSBImageEffect.Effect_Crop(Bounds: TRect): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Crop(B1, Result, Bounds);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Blur with using convolution 3x3      -  ͸ 
//****************************************************************************
procedure TSBImageEffect.Blur(var Src, Dst: TBitmap);
Var
  Ray : array [0..8] of Integer;
  z : word;
begin
  Ray[0] :=  3; Ray[1] :=  3; Ray[2] :=  3;
  Ray[3] :=  3; Ray[4] :=  8; Ray[5] :=  3;
  Ray[6] :=  3; Ray[7] :=  3; Ray[8] :=  3;
  z := 32;
  Dst := Adjust(Ray, z, Src);
end;
//****************************************************************************
// public: Blur Լȣ 
//****************************************************************************
function TSBImageEffect.Effect_Blur: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Blur(B1, Result);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
End;
//****************************************************************************
// public: BlurԼȣ. Source Bitmap Image  
//****************************************************************************
function TSBImageEffect.Effect_Blur(Src: TBitmap): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  B1.Assign (Src);
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Blur(B1, Result);
  B1.Free;
end;
//****************************************************************************
// Sharpen effect using convolution 3x3   -  ͸ 
//****************************************************************************
procedure TSBImageEffect.Sharpen(var Src, Dst: TBitmap);
Var
  Ray : array [0..8] of Integer;
  z : word;
begin
  Ray[0] :=  -1; Ray[1] :=  -1; Ray[2] :=  -1;
  Ray[3] :=  -1; Ray[4] :=  16; Ray[5] :=  -1;
  Ray[6] :=  -1; Ray[7] :=  -1; Ray[8] :=  -1;
  z := 8;
  Dst := Adjust(Ray, z, Src);
end;

function TSBImageEffect.Effect_Sharpen: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
	Sharpen(B1, Result);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;

function TSBImageEffect.Effect_Sharpen(Src: TBitmap): TBitmap;
Var
	B1: TBitmap;
begin
  B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  B1.Assign (Src);
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Sharpen(B1, Result);
  B1.Free;
end;

function TSBImageEffect.Effect_Rotate(Angle: Integer; AntiAlias: Boolean): TBitmap;
Var
	B1, B2: TBitmap;
  Alpha, Scale: Single;
  Sx, Sy: Single;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

	B2 := TBitmap.Create;
  B2.PixelFormat := pf24bit;

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Width := B1.Width;
  Result.Height := B1.Height;

  Alpha := Angle * 3.14159265358979 / 180;

  // Get the width and height of rotated image (without scaling)
  Sx := Abs(B1.Width * Cos(Alpha)) + Abs(B1.Height * Sin(Alpha));
  Sy := Abs(B1.Width * Sin(Alpha)) + Abs(B1.Height * Cos(Alpha));

  B2.Width := Round(Sx);
  B2.Height := Round(Sy);
	SmoothRotate(B1, B2, B2.Width Div 2, B2.Height Div 2, Angle);

  // Calculate a new scale so that the image fits in original boundaries
  Sx := B1.Width / Sx;
  Sy := B1.Height / Sy;

  Scale := Min(Sx, Sy);
  // Resize a new scale.
  Zoom(B2, B2, Scale*100, AntiAlias);

	Result.Canvas.Draw(B1.Width Div 2 - B2.Width Div 2, B1.Height Div 2 - B2.Height Div 2, B2);

	B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// ȿ ó ̹ Ѵ.
//****************************************************************************
procedure TSBImageEffect.SetUsedBmp(const Value: TBitmap);
begin
  FUsedBmp := Value;
end;
//****************************************************************************
// Zoom  /  
//****************************************************************************
function TSBImageEffect.Effect_ZoomXY(ScaleX, ScaleY: Single;
  AntiAlias: Boolean): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  B1.PixelFormat := pf24bit;
  If FUseSource Then
    B1.Assign(FSourceBmp)
  Else
    B1.Assign(FUsedBmp);

  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Assign(B1);
  ZoomXY(B1, Result, ScaleX, ScaleY, AntiAlias);
  B1.Free;
  FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Zoom  /  
//****************************************************************************
procedure TSBImageEffect.ZoomXY(var Src, Dst: TBitmap; ScaleX,
  ScaleY: Single; bAntiAlias: Boolean);
Var
  W, H: Integer;
Begin
	W := Round(Src.Width * ScaleX / 100);
  H := Round(Src.Height * ScaleY / 100);
  Dst.Width := W;
  Dst.Height := H;
	Dst.Canvas.StretchDraw(Rect(0,0,W,H), Src);
  If (bAntiAlias) Then
  	AntiAlias(Dst);
end;
//****************************************************************************
// public: Sharpen Edge.
//****************************************************************************
function TSBImageEffect.Effect_SharpenEdge: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  	B1.PixelFormat := pf24bit;
  	If FUseSource Then
    	B1.Assign(FSourceBmp)
  	Else
    	B1.Assign(FUsedBmp);

  	Result := TBitmap.Create;
  	Result.PixelFormat := pf24bit;
  	SharpenEdge(B1, Result);
  	B1.Free;
  	FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Sharpen Edge
//****************************************************************************
procedure TSBImageEffect.SharpenEdge(var Src, Dst: TBitmap);
Var
  Ray : array [0..8] of Integer;
  z : word;
begin
  //  
    Ray[0] := -1; Ray[1] := -4;  Ray[2] := -1;
    Ray[3] := -4; Ray[4] := 64;  Ray[5] := -4;
    Ray[6] := -1; Ray[7] := -4;  Ray[8] := -1;
    z := 43;
  	Dst := Adjust(Ray, z, Src);
End;
//****************************************************************************
// Brighten
//****************************************************************************
procedure TSBImageEffect.Brighten(Var Bmp: TBitmap);
var
  	h, w : integer;
  	pc : pRGBArray;
begin
  	For h := 0 to Bmp.Height - 1 do
  	Begin
    	pc := Bmp.ScanLine[h];
    	For w := 0 to Bmp.Width - 1 do
    	Begin
          pc[w].rgbtRed := Set255(pc[w].rgbtRed + Round(pc[w].rgbtRed * 0.03));
          pc[w].rgbtGreen := Set255(pc[w].rgbtGreen + Round(pc[w].rgbtGreen * 0.03));
          pc[w].rgbtBlue := Set255(pc[w].rgbtBlue + Round(pc[w].rgbtBlue * 0.03));
    	End;
  	End;

end;
//****************************************************************************
// public: Brighten
//****************************************************************************
function TSBImageEffect.Effect_Brighten: TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  	B1.PixelFormat := pf24bit;
  	If FUseSource Then
    	B1.Assign(FSourceBmp)
  	Else
    	B1.Assign(FUsedBmp);

  	Result := TBitmap.Create;
  	Result.PixelFormat := pf24bit;
    Result.Assign(B1);
  	Brighten(Result);
  	B1.Free;
  	FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// public: Spray.
//****************************************************************************
function TSBImageEffect.Effect_Spray(Amount: Integer): TBitmap;
Var
	B1: TBitmap;
begin
	B1 := TBitmap.Create;
  	B1.PixelFormat := pf24bit;
  	If FUseSource Then
    	B1.Assign(FSourceBmp)
  	Else
    	B1.Assign(FUsedBmp);

  	Result := TBitmap.Create;
  	Result.PixelFormat := pf24bit;
    Result.Assign(B1);
  	Spray(B1, Result, Amount);
  	B1.Free;
  	FUsedBmp.Assign(Result); // reserve image processed image effect.
end;
//****************************************************************************
// Spray effect
//****************************************************************************
procedure TSBImageEffect.Spray(var Src, Dst: TBitmap; Amount: Integer);
var
  a, i, j, x, y, Val : Integer;
  pb, pc : pRGBArray;
begin
  	a := Amount;
  	for j:=0 to Dst.Height-1 do
  	for i:=0 to Dst.Width-1 do
    Begin
    	Val := Random(a);
        x := i+Val-Random(Val*2);
        y := j+Val-Random(Val*2);
        If(x>=0) and (x<Dst.Width) and (y>=0) and (y<Dst.Height) then
        Begin
          	pb := Src.ScanLine[y];
          	pc := Dst.ScanLine[j];
          	pc[i] := pb[x];
        End;
    End;
End;

End.
